/*
** Author: Dimitris Diochnos
** e-mail: diochnos@gmail.com
**
** File Name: mighty_classes.h
**
** Date Started : 20 April 2006.
** Date Finished: 28 April 2006.
**
** Tab space: 3
**
**
** Declarations for the 'Hero' class.
**
*/

#ifndef MIGHTY_CLASSES_H
#define MIGHTY_CLASSES_H

#include <cstring>
#include <cctype>

#include "sec_skills_mighty.h"

/*****************************************************************************/

class Hero {
	public:
								Hero (const unsigned char, const unsigned char name);
								~Hero ();
		unsigned char     get_magic_schools () const;
		bool              get_has_wisdom () const;
		unsigned char     get_hero_level () const;
		double *          ANSA_policy ();
		double            ANSA_policy_combinations (const int size, unsigned char **selectionArray);
		void              print_Name () const;


	private:
		bool 					is_magic_school (const unsigned char skill) const;
		void 					depth_first_search (const unsigned char, bool *, unsigned char *, const unsigned char, bool, const double, const unsigned char, double *);
		void 					depth_first_search_combinations (const unsigned char, bool *, unsigned char *, const unsigned char, bool, const double, const unsigned char, double *, const int, unsigned char **);

		unsigned char     classification;
		unsigned char     name;
		unsigned char     level;
		unsigned char     initial_skills;
		unsigned char     skills [SKILL_SLOTS];
		unsigned char     expertize [SKILL_SLOTS];
		unsigned char     magic_schools;
		bool              has_wisdom;
		unsigned char *   skill_chances;
};

typedef Hero HERO;
typedef HERO * HERO_PTR;

/*****************************************************************************/

char * 	get_skill_name (const unsigned char pointer);
char * 	get_skill_name_12 (const unsigned char pointer);
unsigned char determine_skill (char * input);

/*****************************************************************************/

#endif
